ChunkedInputStream (HttpClient Library (Version 3.1))
Date: 2019-09-02

org.apache.commons.httpclient

## Class ChunkedInputStream

- java.lang.Object
- - java.io.InputStream
  - - org.apache.commons.httpclient.ChunkedInputStream

- All Implemented Interfaces:
    java.io.Closeable, java.lang.AutoCloseable

      public class ChunkedInputStream
      extends java.io.InputStream

  Transparently coalesces chunks of a HTTP stream that uses Transfer-Encoding chunked.

  Note that this class NEVER closes the underlying stream, even when close gets called. Instead, it will read until the "end" of its chunking on close, which allows for the seamless invocation of subsequent HTTP 1.1 calls, while not requiring the client to remember to read the entire contents of the response.

  Since:
    2.0
  Author:
    Ortwin Glueck, Sean C. Sullivan, Martin Elwin, Eric Johnson, Mike Bowler, Michael Becke, Oleg Kalnichevski

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ChunkedInputStream(java.io.InputStream in)` ChunkedInputStream constructor
    `ChunkedInputStream(java.io.InputStream in, HttpMethod method)` ChunkedInputStream constructor that associates the chunked input stream with a `HTTP method`.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Upon close, this reads the remainder of the chunked message, leaving the underlying socket at a position to start reading the next response without scanning.
    `int` | `read()` Returns all the data in a chunked stream in coalesced form.
    `int` | `read(byte[] b)` Read some bytes from the stream.
    `int` | `read(byte[] b, int off, int len)` Read some bytes from the stream.

    - ### Methods inherited from class java.io.InputStream

      `available, mark, markSupported, reset, skip`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ChunkedInputStream

          public ChunkedInputStream(java.io.InputStream in,
                                    HttpMethod method)
                             throws java.io.IOException

      ChunkedInputStream constructor that associates the chunked input stream with a `HTTP method`. Usually it should be the same `HTTP method` the chunked input stream originates from. If chunked input stream contains any footers (trailing headers), they will be added to the associated `HTTP method`.
      Parameters:
        `in` - the raw input stream
        `method` - the HTTP method to associate this input stream with. Can be `null`.
      Throws:
        `java.io.IOException` - If an IO error occurs

    - #### ChunkedInputStream

          public ChunkedInputStream(java.io.InputStream in)
                             throws java.io.IOException

      ChunkedInputStream constructor
      Parameters:
        `in` - the raw input stream
      Throws:
        `java.io.IOException` - If an IO error occurs

  - ### Method Detail

    - #### read

          public int read()
                   throws java.io.IOException

      Returns all the data in a chunked stream in coalesced form. A chunk is followed by a CRLF. The method returns -1 as soon as a chunksize of 0 is detected.

      Trailer headers are read automcatically at the end of the stream and can be obtained with the getResponseFooters() method.

      Specified by:
        `read` in class `java.io.InputStream`
      Returns:
        -1 of the end of the stream has been reached or the next data byte
      Throws:
        `java.io.IOException` - If an IO problem occurs
      See Also:
        `HttpMethod.getResponseFooters()`

    - #### read

          public int read(byte[] b,
                          int off,
                          int len)
                   throws java.io.IOException

      Read some bytes from the stream.
      Overrides:
        `read` in class `java.io.InputStream`
      Parameters:
        `b` - The byte array that will hold the contents from the stream.
        `off` - The offset into the byte array at which bytes will start to be placed.
        `len` - the maximum number of bytes that can be returned.
      Returns:
        The number of bytes returned or -1 if the end of stream has been reached.
      Throws:
        `java.io.IOException` - if an IO problem occurs.
      See Also:
        `InputStream.read(byte[], int, int)`

    - #### read

          public int read(byte[] b)
                   throws java.io.IOException

      Read some bytes from the stream.
      Overrides:
        `read` in class `java.io.InputStream`
      Parameters:
        `b` - The byte array that will hold the contents from the stream.
      Returns:
        The number of bytes returned or -1 if the end of stream has been reached.
      Throws:
        `java.io.IOException` - if an IO problem occurs.
      See Also:
        `InputStream.read(byte[])`

    - #### close

          public void close()
                     throws java.io.IOException

      Upon close, this reads the remainder of the chunked message, leaving the underlying socket at a position to start reading the next response without scanning.
      Specified by:
        `close` in interface `java.io.Closeable`
      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Overrides:
        `close` in class `java.io.InputStream`
      Throws:
        `java.io.IOException` - If an IO problem occurs.

Copyright (c) 1999-2005 - Apache Software Foundation